define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for DistribucionOrdenesOperador generated by Appery.io
         * @module DistribucionOrdenesOperador
         */
        APP.controller('DistribucionOrdenesOperador', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.ordenesTotal = Apperyio.EntityAPI('Number');
            $scope.orders = Apperyio.EntityAPI('Ordenes');
            $scope.codigoBuscar = Apperyio.EntityAPI('String');
            $scope.marcaBuscar = Apperyio.EntityAPI('String');
            $scope.estadoBuscar = Apperyio.EntityAPI('String');
            $scope.operadorBuscar = Apperyio.EntityAPI('String');
            $scope.markers = Apperyio.EntityAPI('Markers');
            $scope.ordenesBloques = Apperyio.EntityAPI('Ordenes');
            $scope.estadoOp = Apperyio.EntityAPI('listaEstadosOperacion');
            /**
             * User controller functions
             */
            /**
             * @function init
             * @param fechaAsignacion
             */
            $scope.init = function(fechaAsignacion) {
                //On load screen logic
                $scope.operatorId = Apperyio.get('userManager').operatorId;
                $scope.operatorName = Apperyio.get('userManager').operatorName;
                $scope.minFechaSelect = formatDateNow2($scope.diasSeleccionCalendarioRetro);
                $scope.mapCtrl = {
                    latitude: -33.502113,
                    longitude: -70.693409,
                    zoom: 10
                };
                $scope.orders = [];
                $scope.ordenesTotal = $scope.orders.length;
                $scope.mostrarMapa = false;
                $scope.textoBotnVerMapa = "Mostrar Mapa";
                $scope.markers = [];
                $scope.fechaAsignacionData = fechaAsignacion ? formatDate3(fechaAsignacion.toISOString()) : formatDateNow2(1);
                $scope.fechaAsignacionGlobal = fechaAsignacion;
                $scope.datosEmpresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.estadoOp = JSON.parse(localStorage.getItem("diasOperacion"));
                $scope.ordenesBloques = [];
                $scope.cantOrdenes = 0;
                $scope.showLoading();
                var requestData = {};
                requestData = (function mapping5211($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "companyId": $scope.datosEmpresa.idCliente
                            },
                            {
                                "documentStatus": 1
                            },
                            {
                                "operatorCode": $scope.operatorId
                            }
                        ]
                    };
                    requestData.params.sort = "assignmentDate";
                    return requestData;
                    /*|button_mapping|onbeforesend|CDF6683C-5833-D021-8627-E23BE397CDEA||5211|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_query_service")(requestData).then( /*|service_bookmark|bookmark|CDF6683C-5833-D021-8627-E23BE397CDEA||9415|*/
                    function(success) { // success callback
                        (function mapping3777(success, $scope) {
                            var ordenesBloques_scope = $scope.ordenesBloques;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(ordenesBloques_scope, '[' + i + '].codigo', success.data[i].documentCode);
                                _.set(ordenesBloques_scope, '[' + i + '].tipoServicio', success.data[i].formType);
                                _.set(ordenesBloques_scope, '[' + i + '].subTipoServicio', success.data[i].formSubType);
                                //            _.set(ordenesBloques_scope, '[' + i + '].fechaEstimada', success.data[i].fechaEstimada);
                                _.set(ordenesBloques_scope, '[' + i + '].fechaAsignacionData', success.data[i].assignmentDate.split(" ")[0]);
                                _.set(ordenesBloques_scope, '[' + i + '].ingeniero', success.data[i].operatorCode);
                                _.set(ordenesBloques_scope, '[' + i + '].mark', success.data[i].assignmentLocation);
                                if (ordenesBloques_scope[i].mark) {
                                    ordenesBloques_scope[i].mark.options = $scope.stateList[success.data[i].documentStatus].optionsLocation;
                                }
                                _.set(ordenesBloques_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(ordenesBloques_scope, '[' + i + '].color', $scope.stateList[success.data[i].documentStatus].color);
                                _.set(ordenesBloques_scope, '[' + i + '].colorExistePosGPS', success.data[i].assignmentLocation ? "default" : "danger");
                                _.set(ordenesBloques_scope, '[' + i + '].msgNoPosGPS', success.data[i].assignmentLocation ? "" : " (POSICION GPS NO DETERMINADA)");
                            }
                            $scope.ordenesBloques = ordenesBloques_scope;
                            /*|button_mapping|onsuccess|CDF6683C-5833-D021-8627-E23BE397CDEA||3777|*/
                            $scope.cantOrdenes = $scope.ordenesBloques.length;
                            $scope.stopLoading();
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al recuperar las órdenes: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function descargar
             */
            $scope.descargar = function() {
                tableToExcel('dataTable', 'Ordenes');
            };
            /**
             * @function formatDate1
             * @param fecha
             */
            function formatDate1(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(".");
                return arrFecha[2] + "-" + arrFecha[0] + "-" + arrFecha[1];
            };
            /**
             * @function buscarOrdenes
             */
            $scope.buscarOrdenes = function() {
                $scope.orders = [];
                $scope.ordenesTotal = $scope.orders.length;
                $scope.markers = [];
                var requestData = {};
                requestData = (function mapping9688($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [
                            ($scope.codigoBuscar) ? {
                                "codigo": $scope.codigoBuscar
                            } : {},
                            ($scope.marcaBuscar != "0" && $scope.marcaBuscar != "") ? {
                                "marca": $scope.marcaBuscar
                            } : {},
                            ($scope.estadoBuscar != "0" && $scope.estadoBuscar != "") ? {
                                "estado": $scope.estadoBuscar
                            } : {},
                            ($scope.operadorBuscar != "0" && $scope.operadorBuscar != "") ? {
                                "idOperador": $scope.operadorBuscar
                            } : {},
                        ]
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|0C90AEF2-D0C1-6BDD-C408-473C557EE902||9688|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_ORDERS_query_service")(requestData).then( /*|service_bookmark|bookmark|0C90AEF2-D0C1-6BDD-C408-473C557EE902||3904|*/
                    function(success) { // success callback
                        (function mapping1876(success, $scope) {
                            var orders_scope = $scope.orders;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(orders_scope, '[' + i + '].codigo', success.data[i].codigo);
                                _.set(orders_scope, '[' + i + '].estado', success.data[i].estado);
                                _.set(orders_scope, '[' + i + '].marca', success.data[i].marca);
                                _.set(orders_scope, '[' + i + '].cliente', success.data[i].nombreCliente);
                                _.set(orders_scope, '[' + i + '].fechaSolicitud', success.data[i].fechaAsignacion);
                                _.set(orders_scope, '[' + i + '].comuna', success.data[i].comuna);
                                _.set(orders_scope, '[' + i + '].ingeniero', success.data[i].idOperador);
                                _.set(orders_scope, '[' + i + '].tipoServicio', success.data[i].tipoServicio);
                                _.set(orders_scope, '[' + i + '].fechaCompra', success.data[i].fechaCompra);
                                _.set(orders_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(orders_scope, '[' + i + '].posGpsFinServicio', success.data[i].posGpsFinServicio);
                                imarker = JSON.parse(success.data[i].posGpsFinServicio);
                                $scope.markers.push(imarker);
                            }
                            $scope.orders = orders_scope;
                            /*|button_mapping|onsuccess|0C90AEF2-D0C1-6BDD-C408-473C557EE902||1876|*/
                            $scope.ordenesTotal = $scope.orders.length
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function verFicha
             * @param orden
             */
            $scope.verFicha = function(orden) {
                Apperyio.get('userManager').orderId = orden;
                Apperyio.navigateTo("FichaOrden");
            };
            /**
             * @function mostrarMapaEnPantalla
             */
            $scope.mostrarMapaEnPantalla = function() {
                $scope.mostrarMapa = !$scope.mostrarMapa;
                if ($scope.mostrarMapa)
                    $scope.textoBotnVerMapa = "Ocultar Mapa";
                else
                    $scope.textoBotnVerMapa = "Mostrar Mapa";
            };
            /**
             * @function showmsg
             */
            $scope.showmsg = function() {
                alert(1);
            };
            /**
             * @function formatDateNow2
             * @param dias
             */
            function formatDateNow2(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                var dd = today.getDate();
                var mm = today.getMonth() + 1;
                var yyyy = today.getFullYear();
                return yyyy + '-' + $scope.addZero(mm) + '-' + addZero(dd);
            };
            /**
             * @function formatDate3
             * @param dat
             */
            function formatDate3(dat) {
                var fecha = dat.split("T");
                return fecha[0];
            };
            /**
             * @function reasignarFecha
             * @param orden
             * @param fecha
             */
            $scope.reasignarFecha = function(orden, fecha) {
                //Por defecto siempre se mueve en estado CREADA
                var estadoMover = 1;
                //Validar que no se aplique a un día asignado
                for (var i in $scope.estadoOp) {
                    if (formatDate3(fecha.toISOString()) == $scope.estadoOp[i].fecha) {
                        if ($scope.mConfirm("La fecha a la que está intentando mover la orden ya está procesada. Desea mover la orden de todas maneras")) {
                            //La orden llega al día cerrado en estado lista para descarga
                            estadoMover = 2;
                        } else {
                            //Buscar el modelo para devolver la fecha
                            for (var j in $scope.ordenesBloques) {
                                if ($scope.ordenesBloques[j]._id == orden) {
                                    $scope.ordenesBloques[j].fechaAsignacionModel = formData44($scope.ordenesBloques[j].fechaAsignacionData);
                                    break;
                                }
                            }
                            return;
                        }
                    }
                }
                var requestData = {};
                requestData = (function mapping8756($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.data = {};
                    requestData.params._id = orden;
                    _.set(requestData.data, 'documentStatus', estadoMover);
                    _.set(requestData.data, 'deviceData.enDispositivo', false);
                    _.set(requestData.data, 'assignmentDate', formatDate3(fecha.toISOString()));
                    return requestData;
                    /*|button_mapping|onbeforesend|6E5E699F-A8D9-A45D-04D1-BA32151C751D||8756|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_update_service")(requestData).then( /*|service_bookmark|bookmark|6E5E699F-A8D9-A45D-04D1-BA32151C751D||5129|*/
                    function(success) { // success callback
                        /*|button_mapping|onsuccess|6E5E699F-A8D9-A45D-04D1-BA32151C751D||9688|*/
                        //Buscar el modelo para eliminar el registro
                        /*for (var k in $scope.ordenesBloques) {
                            if ($scope.ordenesBloques[k]._id == orden) {
                                $scope.ordenesBloques.splice(k, 1);
                                break;
                            }
                        }*/
                    },
                    function(error) { // callback to handle request error
                        alert(JSON.stringify(error));
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function distribuirDia
             */
            $scope.distribuirDia = function() {
                if ($scope.mConfirm("Esta acción asignará el trabajo a los operadores y no podrá deshacerse.\n¿Desea continuar?")) {
                    var requestData = {};
                    requestData = (function mapping1587($scope) {
                        var requestData = {};
                        requestData.data = {};
                        _.set(requestData.data, 'idEmpresa', $scope.datosEmpresa.idCliente);
                        _.set(requestData.data, 'fechaOperacion', $scope.fechaAsignacionGlobal ? formatDate3($scope.fechaAsignacionGlobal.toISOString()) : formatDateNow2(1));
                        _.set(requestData.data, 'estadoOperacion', true);
                        return requestData;
                        /*|button_mapping|onbeforesend|116AEE02-403D-44F9-04A7-163B300A2339||1587|*/
                    })($scope);
                    // read more about using rest services: https://links.appery.io/ve-snippet-rest
                    Apperyio.get("Tech1_OPERATIONDAY_create_service")(requestData).then( /*|service_bookmark|bookmark|116AEE02-403D-44F9-04A7-163B300A2339||4536|*/
                        function(success) { // success callback
                            /*|button_mapping|onsuccess|116AEE02-403D-44F9-04A7-163B300A2339||6473|*/
                            var listaCodigosUpdate = [];
                            //Armar el arreglo de códigos de ordenes
                            for (var j in $scope.operators) {
                                for (var k in $scope.operators[j].ordenes) {
                                    listaCodigosUpdate.push($scope.operators[j].ordenes[k]._id);
                                }
                            }
                            //Cambisar el estado de las órdenes del día distribuido vía ServerCode
                            var requestData = {};
                            requestData = (function mapping1733($scope) {
                                var requestData = {};
                                requestData.params = {};
                                requestData.params.listaCodigos = JSON.stringify(listaCodigosUpdate);
                                requestData.params.idEmpresa = $scope.datosEmpresa.idCliente;
                                return requestData;
                                /*|button_mapping|onbeforesend|FE72B83E-77CE-792A-B18B-75876E6767BE||1733|*/
                            })($scope);
                            // read more about using rest services: https://links.appery.io/ve-snippet-rest
                            Apperyio.get("updateMassiveOrdersState_service")(requestData).then( /*|service_bookmark|bookmark|FE72B83E-77CE-792A-B18B-75876E6767BE||8772|*/
                                function(success) { // success callback
                                    /*|button_mapping|onbeforesend|5E7AC57C-46EB-4023-DEBE-4C461EF2DE9F||6297|*/
                                    $scope.init($scope.fechaAsignacionGlobal);
                                },
                                function(error) { // callback to handle request error
                                },
                                function(notify) { // notify callback, can fire few times
                                });
                        },
                        function(error) { // callback to handle request error
                        },
                        function(notify) { // notify callback, can fire few times
                        });
                }
            };
            /**
             * @function formDate4
             * @param fecha
             */
            function formDate4(fecha) {
                if (!fecha)
                    return fecha;
                var arrFecha = fecha.split(" ");
                var a1 = arrFecha[0];
                var a1Arr = a1.split("-");
                return new Date(a1Arr[0], a1Arr[1] - 1, a1Arr[2]);
            };
            /**
             * @function formData5
             * @param dias
             */
            function formData5(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                return today;
            };
            /**
             * @function formData44
             * @param fecha
             */
            function formData44(fecha) {
                if (!fecha)
                    return fecha;
                var a1Arr = fecha.split("-");
                return new Date(a1Arr[0], a1Arr[1] - 1, a1Arr[2]);
            };
            /**
             * @function setCenterMap
             * @param mark
             */
            $scope.setCenterMap = function(mark) {
                $scope.mapCtrl = mark;
                $scope.mapCtrl.zoom = 14;
            };
        }
    });